import {
  select,
  csv,
  scaleLinear,
  extent,
  axisLeft,
  axisBottom,
  format
} from 'd3';


const svg1 = select('body')
  .append('svg')
  .attr('class', 'svg1');

svg1
  .attr('width', 960)
  .attr('height', 250)  

const svg2 = select('body')
  .append('svg')
  .attr('class', 'svg2');;

svg2
  .attr('width', 960)
  .attr('height', 250) 

const audioEle = select('#audioElement')
const audioEleSrc = select('#audioElementSrc')
  

const width1 = +svg1.attr('width');
const height1 = +svg1.attr('height');

var tooltipdiv = d3.select("body").append("div")	
    .attr("class", "tooltip")				
    .style("opacity", 0);

const render = data => {
  const title1 = 'metric';
  
  const xValue1 = d => d.metric1;
  const xAxisLabel1 = 'index';
  
  const yValue1 = d => d.index;
  const circleRadius1 = 5;
  const yAxisLabel1 = 'metric1';
  
  const margin1 = { top: 60, right: 40, bottom: 88, left: 150 };
  const innerWidth1 = width1 - margin1.left - margin1.right;
  const innerHeight1 = height1 - margin1.top - margin1.bottom;
  
  const xScale1 = scaleLinear()
    .domain(extent(data, xValue1))
    .range([0, innerWidth1])
    .nice();
  
  const yScale1 = scaleLinear()
    .domain(extent(data, yValue1))
    .range([innerHeight1, 0])
    .nice();
  
  const g1 = svg1.append('g')
    .attr('transform', `translate(${margin1.left},${margin1.top})`);
  
  const xAxis1 = axisBottom(xScale1)
    .tickSize(-innerHeight1)
    .tickPadding(15);
  
  const yAxis1 = axisLeft(yScale1)
    .tickSize(-innerWidth1)
    .tickPadding(10);
  
  const yAxisG1 = g1.append('g').call(yAxis1);
  yAxisG1.selectAll('.domain').remove();
  
  yAxisG1.append('text')
      .attr('class', 'axis-label')
      .attr('y', -93)
      .attr('x', -innerHeight1 / 2)
      .attr('fill', 'black')
      .attr('transform', `rotate(-90)`)
      .attr('text-anchor', 'middle')
      .text(yAxisLabel1);
  
  const xAxisG1 = g1.append('g').call(xAxis1)
    .attr('transform', `translate(0,${innerHeight1})`);
  
  xAxisG1.select('.domain').remove();
  
  xAxisG1.append('text')
      .attr('class', 'axis-label')
      .attr('y', 75)
      .attr('x', innerWidth1 / 2)
      .attr('fill', 'black')
      .text(xAxisLabel1);
  
  g1.selectAll('circle').data(data)
    .enter().append('circle')
      .attr('cy', d => yScale1(yValue1(d)))
      .attr('cx', d => xScale1(xValue1(d)))
      .attr('r', circleRadius1)
      .on("mouseover", function(d) {
    	  console.log(d)
        tooltipdiv.transition()		
            .duration(200)		
            .style("opacity", .9);		
        tooltipdiv	.html("ID:" + d.index)	
            .style("left", (d3.event.pageX) + "px")		
            .style("top", (d3.event.pageY - 28) + "px");	
        })					
      .on("mouseout", function(d) {		
        tooltipdiv.transition()		
            .duration(500)		
            .style("opacity", 0);	
      })
      .on("click", function(d) {
          console.log(d.index)
    			render2(d.index)
        });
  
  
  g1.append('text')
      .attr('class', 'title')
      .attr('y', -10)
      .text(title1);
};

const width2 = +svg2.attr('width');
const height2 = +svg2.attr('height');

const render2 = index => {
  console.log("render2 start")
  function filterCriteria(d) {
    return d.index == index;
  }
  csv('https://vizhub.com/kkawabat/datasets/audiourl.csv')
  .then(data => {
  var newData = data.filter(filterCriteria);
    console.log(newData[0].audio_url);
    audioEleSrc.node().src = newData[0].audio_url;
    audioEle.node().load();
    audioEle.node().play();
    console.log(svg2.node())
  });
};


csv('https://vizhub.com/kkawabat/datasets/testcsv.csv')
  .then(data => {
    data.forEach(d => {
      d.index = +d.index;
      d.metric1 = +d.metric1;
      d.metric1 = +d.metric2;
    });
    render(data);
  });